"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.Worker = void 0;
var bull_1 = __importDefault(require("bull"));
var uuid_1 = require("uuid");
var logger_1 = __importDefault(require("./utils/logger"));
var CodeExecutor = /** @class */ (function () {
    function CodeExecutor(name, redis) {
        var _this = this;
        this.queue = new bull_1["default"](name, redis);
        this.jobs = new Map();
        this.queue.on('global:completed', function (_job, result) {
            var id = JSON.parse(result).id;
            logger_1["default"].debug("Running on complete for id: " + id);
            var currentJob = _this.jobs.get(id);
            if (currentJob) {
                currentJob.resolve(result);
                _this.jobs["delete"](id);
            }
        });
    }
    CodeExecutor.prototype.runCode = function (codeOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var id, codeObject;
            var _this = this;
            return __generator(this, function (_a) {
                id = uuid_1.v4();
                codeObject = __assign(__assign({}, codeOptions), { id: id });
                logger_1["default"].info("Running code with id: " + id);
                return [2 /*return*/, new Promise(function (resolve, reject) {
                        _this.jobs.set(id, { resolve: resolve, reject: reject });
                        _this.queue.add(codeObject);
                    })];
            });
        });
    };
    CodeExecutor.prototype.stop = function () {
        this.queue.close();
    };
    return CodeExecutor;
}());
exports["default"] = CodeExecutor;
var Worker_1 = require("./Worker");
__createBinding(exports, Worker_1, "default", "Worker");
